from django.db import models
from base import BaseModel
from settings import SERVER_CHOICES, EMAIL_CHOICES, DB_CHOICES, PROJECT_TYPES


class DomainBase(BaseModel):
    url = models.CharField(max_length=512)
    server = models.CharField(choices=SERVER_CHOICES, blank=True, max_length=128)
    email = models.CharField(choices=EMAIL_CHOICES, blank=True)
    path = models.CharField(max_length=255, blank=True)
    project_type = models.CharField(choices=PROJECT_TYPES, blank=True)
    db_type = models.CharField(choices=DB_CHOICES, blank=True)
    db_name = models.CharField(max_length=255, blank=True)
    
    class Meta:
        abstract = True
    
    def __unicode__(self):
        return self.url


class Domain(DomainBase):
    pass


class Subdomain(DomainBase):
    main_domain = models.ForeignKey(Domain)